#%RAML 0.8
title: Hack.Space Admin
version: v0.3.0
baseUri: /api/admin

securitySchemes: 
  - basic:
      type: x-JWT
      describedBy: 
        headers:
          Authorization:
            description: Should contain jwt-token
            type: string
        responses: 
          401:
            description: Missing or invalid JWT token
            body:
              application/json:
                example: |
                  { "message":"Missing/incorrect JWT" }
          403:
            description: Insufficient privileges
            body:
              application/json:
                example: |
                  { "message":"Not authorized" }
  - bot-auth:
      type: x-Bot
      describedBy: 
        headers:
          Authorization:
            description: Should contain bot-token
            type: string
        responses:
          401:
            description: Missing or invalid Bot token
            body:
              application/json:
                example: |
                  { "message":"Missing/incorrect token" }
          403:
            description: Insufficient privileges
            body:
              application/json:
                example: |
                  { "message":"Not authorized" }

traits:
  - response-404:
      responses:
        404:
          description: Resource not found
          body:
            application/json:
              example: |
                { "message":"Resource not found" }
  - response-409:
      responses:
        409:
          description: Conflict. Document already exists
          body:
            application/json:
              example: |
                { "message":"Conflict" }
  - response-400:
      responses:
        400:
          description: Bad request
          body:
            application/json:
              example: |
                { "message":"Bad request" }

schemas: 
  - MessageCreateSchema: !include schemas/messages/create.schema.json
  - MessageListSchema: !include schemas/messages/get.list.schema.json
  - ActorGetSchema: !include schemas/actors/get.schema.json
  - ActorCreateSchema: !include schemas/actors/create.schema.json
  - ActorListSchema: !include schemas/actors/get.list.schema.json
  - ActorUpdateSchema: !include schemas/actors/update.schema.json
  - LoginResponseSchema: !include schemas/login/response.schema.json
  - LoginSchema: !include schemas/login/schema.json
  - OrgGetSchema: !include schemas/orgs/get.schema.json
  - EventGetSchema: !include schemas/events/get.schema.json
  - EventCreateSchema: !include schemas/events/create.schema.json
  - EventListSchema: !include schemas/events/get.list.schema.json
  - EventUpdateSchema: !include schemas/events/update.schema.json
  - StartJudgingSchema: !include schemas/events/startJudging.schema.json
  - PartcipantsGetListSchema: !include schemas/participants/get.list.schema.json
  - CriteriaGetSchema: !include schemas/criterias/get.schema.json
  - CriteriaCreateSchema: !include schemas/criterias/create.schema.json
  - CriteriaListSchema: !include schemas/criterias/get.list.schema.json
  - CriteriaUpdateSchema: !include schemas/criterias/update.schema.json
  - JudgeGetSchema: !include schemas/judges/get.schema.json
  - JudgeCreateSchema: !include schemas/judges/create.schema.json
  - JudgeListSchema: !include schemas/judges/get.list.schema.json
  - JudgeUpdateSchema: !include schemas/judges/update.schema.json
  - JudgeInviteSchema: !include schemas/judges/invite.schema.json
  - TeamGetSchema: !include schemas/teams/get.schema.json
  - TeamCreateSchema: !include schemas/teams/create.schema.json
  - TeamListSchema: !include schemas/teams/get.list.schema.json
  - TeamUpdateSchema: !include schemas/teams/update.schema.json
  - VerdictGetSchema: !include schemas/verdicts/get.schema.json
  - VerdictUpdateSchema: !include schemas/verdicts/update.schema.json
  - VerdictUpdateListSchema: !include schemas/verdicts/update.list.schema.json
  - VerdictListSchema: !include schemas/verdicts/get.list.schema.json
  - VotingStartSchema: !include schemas/voting/start.schema.json
  - VerdictExportSchema: !include schemas/verdicts/export.schema.json
  - VerdictCommentsGetSchema: !include schemas/verdicts/comments.get.schema.json


/login:
  description: Login for organizators.
  post:
    body:
      application/json:
        schema: LoginSchema
        example: !include examples/login/example.json
    responses: 
      200:
        body: 
          application/json:
            schema: LoginResponseSchema
            example: !include examples/login/response.example.json
      401:
  
/actors:
  description: |
    Managing actors and their roles into the organization.
    Id of organization is defined by JWT provided through
    admin's organization ID.
  securedBy: [basic]
  get:
    responses: 
      200:
        body:
          application/json:
            schema: ActorListSchema
            example: !include examples/actors/get.list.example.json      
  post:
    is: [response-400,response-409]
    body: 
      application/json:
        schema: ActorCreateSchema
        example: !include examples/actors/create.example.json
    responses: 
      200:
        body:
          application/json:
            schema: ActorGetSchema
            example: !include examples/actors/get.example.json
  /{id}:
    securedBy: [basic]
    uriParameters: 
      id: 
        description: Id of an actor. Set id = me for fetching info about current user.
        type: number
    get:
      is: [response-404]
      responses: 
        200:
          body:
            application/json:
              schema: ActorGetSchema
              example: !include examples/actors/get.example.json
    put:
      is: [response-400]
      body: 
        application/json:
          schema: ActorUpdateSchema
          example: !include examples/actors/update.example.json
      responses: 
        200:
          body:
            application/json:
              schema: ActorGetSchema
              example: !include examples/actors/get.example.json
    delete:
      responses: 
        200:

/orgs:
  /me:
    description: Fetches description about current user's organization
    get:
      securedBy: [basic]
      responses: 
        200:
          body:
            application/json:
              schema: OrgGetSchema
              example: !include examples/orgs/get.example.json
              
/events:
  description: |
    Managing events. Required role - any (admin or basic).
    Be careful with isDraft field when post events, because non-draft objects
    are mutable (not-editable). When an events is anounced it cannot be updated
    or removed, only drafts do. It is for a while.
  securedBy: [basic]
  get:
    responses: 
      200:
        body:
          application/json:
            schema: EventListSchema
            example: !include examples/events/get.list.example.json      
  post:
    is: [response-400,response-409]
    body: 
      application/json:
        schema: EventCreateSchema
        example: !include examples/events/create.example.json
    responses: 
      200:
        body:
          application/json:
            schema: EventGetSchema
            example: !include examples/events/get.example.json
  /{id}:
    securedBy: [basic]
    uriParameters: 
      id: 
        description: Id of an Event
        type: number
    get:
      is: [response-404]
      responses: 
        200:
          body:
            application/json:
              schema: EventGetSchema
              example: !include examples/events/get.example.json
    put:
      is: [response-400, response-409]
      body: 
        application/json:
          schema: EventUpdateSchema
          example: !include examples/events/update.example.json
      responses: 
        200:
          body:
            application/json:
              schema: EventGetSchema
              example: !include examples/events/get.example.json
        403:
          description: if try update an anounce, not a draft
    delete:
      responses: 
        200:
        403:
          description: if try delete an anounce, not a draft
    
    /startJudging:
      securedBy: [basic]
      post:
        responses:
          200:
            description: |
              if judging is activated (already or after request)
            body:
              application/json:
                schema: StartJudgingSchema
                example: !include examples/events/startJudging.example.json
          400:
            description: |
              if less than 2 teams, 1 judge and 1 criteria in event

/messages:
  get:
    securedBy: [bot-auth]
    is: [response-404]
    queryParameters: 
      eventId:
        description: id of event
        required: true
      lastMessageTimestamp:
        description: last message timestamp in seconds
        required: false
        default: 0
    responses:
      200:
        body:
          application/json:
            schema: MessageListSchema
            example: !include examples/messages/get.list.example.json
  post:
    securedBy: [basic]
    is: [response-400]
    body: 
      application/json:
        schema: MessageCreateSchema
        example: !include examples/messages/create.example.json
    responses: 
      200:

/participants:
  /{id}:
    uriParameters: 
      id:
        description: Event id
    get:
      securedBy: [basic]
      responses:
        200: 
          body:
            application/json:
              schema: PartcipantsGetListSchema
              example: !include examples/participants/get.list.example.json
    /relese-on-hold:
      description: |
        Move statuses from On-Hold to Hacker-Status of participation, so they
        will recieve e-mails about status changing.
      post:
        responses:
          200:
          400:
    /{hackerId}:
      uriParameters: 
        hackerId: 
          description: Applicant ID
      /confirm:
        post:
          securedBy: [basic]
          responses: 
            200:
            400:
            404:
      /decline:
        post:
          securedBy: [basic]
          responses: 
            200:
            400:
            404:
            
# Judging

/teams:
  description: |
    Managing teams. Now it is not integrated with participants, 
    organizator creates teams by own.
  securedBy: [basic]
  get:
    responses: 
      200:
        body:
          application/json:
            schema: TeamListSchema
            example: !include examples/teams/get.list.example.json      
  post:
    is: [response-400,response-409]
    body: 
      application/json:
        schema: TeamCreateSchema
        example: !include examples/teams/create.example.json
    responses: 
      200:
        body:
          application/json:
            schema: TeamGetSchema
            example: !include examples/teams/get.example.json
  /{id}:
    securedBy: [basic]
    uriParameters: 
      id: 
        description: Id of an team. Set id = me for fetching info about current user.
        type: number
    get:
      is: [response-404]
      responses: 
        200:
          body:
            application/json:
              schema: TeamGetSchema
              example: !include examples/teams/get.example.json
    put:
      is: [response-400]
      body: 
        application/json:
          schema: TeamUpdateSchema
          example: !include examples/teams/update.example.json
      responses: 
        200:
          body:
            application/json:
              schema: TeamGetSchema
              example: !include examples/teams/get.example.json
    delete:
      is: [response-400]
      responses: 
        200:

/judges:
  description: |
    Managing judges. After creating new judges they will recieve intivation link to 
    special web page for voting.
  securedBy: [basic]
  get:
    is: [response-400]
    description: |
      Fetches list of judges. Each contains status field, which repesents the following:
      created - judge was just created, and email wasn't sent
      invited - organizator had sent an invitation to the judge
      activated - judge press the link in the email
      completed - judge had finished voting and results were collected
    queryParameters: 
      eventId:
        type: number
        description: Id of an event
        required: true
    responses: 
      200:
        body:
          application/json:
            schema: JudgeListSchema
            example: !include examples/judges/get.list.example.json      
  post:
    is: [response-400]
    description: Creates new judge. After posting invitation link will be generated and returned in response.
    body: 
      application/json:
        schema: JudgeCreateSchema
        example: !include examples/judges/create.example.json
    responses: 
      200:
        body:
          application/json:
            schema: JudgeGetSchema
            example: !include examples/judges/get.example.json
  /{id}:
    securedBy: [basic]
    uriParameters: 
      id: 
        description: Id of a judge.
        type: number
    get:
      is: [response-404]
      responses: 
        200:
          body:
            application/json:
              schema: JudgeGetSchema
              example: !include examples/judges/get.example.json
    put:
      is: [response-400]
      body: 
        application/json:
          schema: JudgeUpdateSchema
          example: !include examples/judges/update.example.json
      responses: 
        200:
          body:
            application/json:
              schema: JudgeGetSchema
              example: !include examples/judges/get.example.json
    delete:
      is: [response-400]
      responses: 
        200:
    /invite:
      securedBy: [basic]
      description: |
        send invitation email to a judge with id.
      post:
        securedBy: [basic]
        is: [response-400, response-404]
        queryParameters: 
          reinvite:
            description: send message again to judges with 'invited' status
            type: boolean
            default: false
        responses: 
          200:
            body:
              application/json:
                schema: JudgeGetSchema
                example: !include examples/judges/get.example.json
  /all/invite:
    description: invite all judges of an event
    securedBy: [basic]
    post:
      is: [response-404]
      queryParameters: 
        reinvite:
          description: send message again to judges with 'invited' status
          type: boolean
          default: false
      body: 
        application/json:
          schema: JudgeInviteSchema
          example: !include examples/judges/invite.example.json
      responses: 
        200:
          body:
            application/json:
              schema: JudgeListSchema
              example: !include examples/judges/get.list.example.json

/criterias:
  description: |
    Managing criterias for judging. 
  securedBy: [basic]
  get:
    is: [response-400]
    queryParameters: 
      eventId:
        type: number
        description: Id of an event
        required: true
    responses: 
      200:
        body:
          application/json:
            schema: CriteriaListSchema
            example: !include examples/criterias/get.list.example.json      
  post:
    is: [response-400]
    body: 
      application/json:
        schema: CriteriaCreateSchema
        example: !include examples/criterias/create.example.json
    responses: 
      200:
        body:
          application/json:
            schema: CriteriaGetSchema
            example: !include examples/criterias/get.example.json
  /{id}:
    securedBy: [basic]
    uriParameters: 
      id: 
        description: Id of a criteria.
        type: number
    get:
      is: [response-404]
      responses: 
        200:
          body:
            application/json:
              schema: CriteriaGetSchema
              example: !include examples/criterias/get.example.json
    put:
      is: [response-400]
      body: 
        application/json:
          schema: CriteriaUpdateSchema
          example: !include examples/criterias/update.example.json
      responses: 
        200:
          body:
            application/json:
              schema: CriteriaGetSchema
              example: !include examples/criterias/get.example.json
    delete:
      is: [response-400]
      responses: 
        200:

/verdicts:
  description: |
    Voting for Judges, and results for of judging for Organizators.
  securedBy: [basic]
  get:
    description: Allowed for organizators (basic and admin)
    queryParameters: 
      eventId:
        type: number
        description: Id of an event
        required: true
    responses: 
      200:
        body:
          application/json:
            schema: VerdictListSchema
            example: !include examples/verdicts/get.list.example.json      

  /export:
    description: |
      Export verdicts to table.
      Allowed for admins with basec or admin access
    securedBy: [basic]
    post: 
      responses:
        200:
          body:
            application/json:
              schema: VerdictExportSchema
              example: !include examples/verdicts/export.example.json
  /list:
    securedBy: [basic]
    description: |
      Allowed for Judges only. The end-point requires Judger's token in
      the Authorization header.
    put:
      is: [response-400,response-404]
      body: 
        application/json:
          schema: VerdictUpdateListSchema
          example: !include examples/verdicts/update.list.example.json
      responses: 
        201:
  /{id}:
    securedBy: [basic]
    description: |
      Allowed for Judges only. The end-point requires Judger's token in
      the Authorization header.
    uriParameters: 
      id: 
        description: Team Id
        type: number
    get:
      is: [response-404]
      responses: 
        200:
          body:
            application/json:
              schema: VerdictGetSchema
              example: !include examples/verdicts/get.example.json
    put:
      is: [response-400,response-404]
      body: 
        application/json:
          schema: VerdictUpdateSchema
          example: !include examples/verdicts/update.example.json
      responses: 
        200:
          body:
            application/json:
              schema: VerdictGetSchema
              example: !include examples/verdicts/get.example.json
    /comments:
      securedBy: [basic]
      get:
        is: [response-404]
        responses: 
          200:
            body:
              application/json:
                schema: VerdictCommentsGetSchema
                example: !include examples/verdicts/comments.get.example.json
 
/voting:
  /start:
    get:
      description: Starts voting by a judge.
      responses: 
        200:
          body:
            application/json:
              schema: VotingStartSchema
              example: !include examples/voting/start.example.json
